<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
   
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">

    <title>Document</title>
</head>
<body>
    <div class="container">
        <div class="text-center m-4 col-sm-12">
            <h2>F200 - LỊCH SỬ HỌC TẬP </h2>
        </div>
        <div class="jumbotron col-sm-12">
            <div class="row">
                <div class="col-sm-2">
                    <label>Sinh Viên</label>
                </div>
                <div class="col-sm-3">
                    <div class="form-group">
                        <select id="select-student" class="form-control select2 select2-danger" data-dropdown-css-class="select2-danger" style="width: 100%;">
                          </select>
                    </div>
                </div>
                <div class="col-sm-2 text-center">
                    <label>Môn Học</label>
                </div>
                <div class="col-sm-3">
                    <div class="form-group">
                        <select id="select-subject" class="form-control select2 select2-danger" data-dropdown-css-class="select2-danger" style="width: 100%;">
                          </select>
                      </div>
                </div>
                <div class="col-sm-2">
                    <button id="btn-loc" class="btn btn-info">Lọc Dữ Liệu</button>
                </div>
            </div>
        </div>
        <div class="text-right">
          <button id="btn-add-new" class="btn btn-success m-4" >Thêm Mới Điểm</button>
        </div>
        <table class="table table-bordered table-striped table-hover" id="table-student">
            <thead class="bg-info">
              <tr>
                <th>STT</th>
                <th>Student</th>
                <th>Môn Học</th>
                <th>Điểm</th>
                <th>Ngày Thi</th>
                <th>Action</th>
              </tr>
            </thead>
          </table>
    </div>

    <!-- Modal -->
    <div id="AddNew-Modal" class="modal fade" role="dialog">
      <div class="modal-dialog modal-lg">

        <!-- Modal content-->
        <div class="modal-content border border-danger">
          <div class="modal-header">
            <h4 class="modal-title text-primary">Thêm Mới Điểm</h4>
            <a type="button" class="btn btn-danger" href="Task48.10.duong.html"> &times; </a>
          </div>
          <div class="modal-body">
            <div class="container">
              <div class="row form-group">
                <div class="col-sm-3 text-center"><label class="font-weight-bold">Sinh Viên</label></div>
                <div class="col-sm-9"><select id="select-studentid-modal" class="form-control"></select></div> 
              </div>
              <div class="row form-group">
                <div class="col-sm-3 text-center"><label class="font-weight-bold">Môn Học</label></div>
                <div class="col-sm-9"><select id="select-subjectid-modal" class="form-control"></select></div> 
              </div>
              <div class="row form-group">
                <div class="col-sm-3 text-center"><label class="font-weight-bold">Điểm</label></div>
                <div class="col-sm-9"><input type="number" class="form-control" id="inp-grade-modal"></div> 
              </div>
              <div class="row form-group">
                <div class="col-sm-3 text-center"><label class="font-weight-bold">Ngày Thi</label></div>
                <div class="col-sm-9"><input type="date" class="form-control" id="inp-examDate-modal"></div> 
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <button class="btn btn-primary w-75 " id="btn-modal-edit">Sửa</button>
            <button class="btn btn-success w-75 " id="btn-modal-Add-new">Thêm</button>
            <a href="Task48.10.duong.html"> Hủy </a>
          </div>
        </div>

      </div>
    </div>
</body>
<script>
    $(document).ready(function(){
    "use strict";
   
  //Vùng 1: định nghĩa global variable (biến toàn cục)
    var gStudent;
    var gSubject;
    var gGrade;
    var gId;
    var gSTT = 1;
    var gradeID;
    const gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/"

    const gObject = ["stt", "studentId", "subjectId", "grade", "examDate", "action"];
    const gSTT_COL = 0;
    const gNAME_COL = 1;
    const gSUBJ_COL = 2;
    const gGRADE_COL = 3;
    const gDATE_COL = 4;
    const gACTION_COL = 5;

    var gObjTable = $("#table-student").DataTable({
        columns: [
            { data: gObject[gSTT_COL] },
            { data: gObject[gNAME_COL] },
            { data: gObject[gSUBJ_COL] },
            { data: gObject[gGRADE_COL] },
            { data: gObject[gDATE_COL] },
            { data: gObject[gACTION_COL] }
        ],
        columnDefs: [
            {
                targets: gSTT_COL,
                render: function () {
                    return gSTT++
                }
            },

            {
                targets: gNAME_COL,
                render: function (paramStudent) {
                    return getFullNameById(paramStudent);
                }
            },
            {
                targets: gSUBJ_COL,
                render: function (paramSubject) {
                    return getSubjectNameById(paramSubject);
                },
            },

            {
                targets: gACTION_COL,
                className: "text-center",
                defaultContent: `
                    <button class="btn btn-link btn-edit" data-toggle="tooltip" data-placement="bottom" title="Edit"><i class="fa-solid fa-pen-to-square text-primary pointer"></i></button>
                    <button class="btn btn-link btn-sm btn-delete" data-toggle="tooltip" data-placement="bottom" title="Delete"><i class="fa-solid fa-trash-can text-danger pointer"></i></button>
              `
            },


        ]
    });


  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
 // GetAllGrade();
  onPageLoading();
  
  $("#btn-loc").on("click",function(){
        onBtnFilterClick();
      });
  $("#btn-add-new").on("click",function(){
      $("#AddNew-Modal").modal("show");
      $("#btn-modal-edit").hide();
      });
  $("#btn-modal-Add-new").on("click",function(){
      onbtnAddNewGradeClick();
      });
  $("#table-student").on("click", ".btn-edit", function(){
      onbtnShowModalEditClick(this);
      });
  $("#btn-modal-edit").on("click", function(){
      onbtnEditClick();
      });
    


    

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
        "use strict"
        StudentList();
        SubjectList();
        loadGradeData(); // gán sự kiện lấy dữ liệu của bảng

        loadDataToSelectStudent(gStudent);
        loadDataToSelectSubject(gSubject);
 
    }
    function onbtnEditClick(){
        // khai báo đối tượng
        var EditObj = {
                studentId: -1,
                subjectId: -1,
                grade: -1,
                examDate: ""
            };
      // B1 Thu thập dữ liệu
      readDataFormModal(EditObj);
      // B2 validate Dữ Liệu
      var CheckModalEdit = validateDataModal(EditObj);
      if(CheckModalEdit){
        console.log(EditObj);
        // B3 Gọi Api Sửa Điểm Môn Cho Học Sinh
        onEditGrade(EditObj);
      }
    }
    // xử lý sự kiên khi ấn nút thêm mới
    function onbtnAddNewGradeClick(){
      // khai báo đối tượng
      var vGradeObjRequest = {
                studentId: -1,
                subjectId: -1,
                grade: -1,
                examDate: ""
            };
      // B1 Thu thập dữ liệu
      readDataFormModal(vGradeObjRequest);
      // B2 validate Dữ Liệu
      var CheckModal = validateDataModal(vGradeObjRequest);
      if(CheckModal){
        console.log(vGradeObjRequest);
        // B3 Gọi Api Thêm Mới Điểm Môn Cho Học Sinh
        onCreateGrade(vGradeObjRequest);
      }
    }
    // hàm show modal edit
    function onbtnShowModalEditClick(paramEditClick){
      $("#btn-modal-Add-new").hide();
      var vRowSelect = $(paramEditClick).closest("tr");
      var vTable = $('#table-student').DataTable();
      var vRowData = vTable.row(vRowSelect).data();
      gradeID = vRowData.id ;
      console.log(vRowData);
      onGetGradeById(vRowData.id)
      $("#AddNew-Modal").modal("show");
    }
    
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // lấy điểm băng id
      function onGetGradeById(paramId){
        $.ajax({
          url:  "https://62454a477701ec8f724fb923.mockapi.io/api/v1/grades/" + paramId,
          type: "GET",
          dataType: "json",
          success: function(response){
            console.log(response);
            addDataToformEdit(response);
          },
          error: function(error){
            alert("Không Lấy Đc Thông Tin")
          }
        })
      };
      function addDataToformEdit(dataObj){
        $("#select-studentid-modal").val(dataObj.studentId);
        $("#select-subjectid-modal").val(dataObj.subjectId);
        $("#inp-grade-modal").val(dataObj.grade);
        $("#inp-examDate-modal").val(dataObj.examDate);
      }
      // B1 Thu thập dữ liệu Modal
      function readDataFormModal(paramObjModal){
        "use strict"
        paramObjModal.studentId = $("#select-studentid-modal").val();
        paramObjModal.subjectId = $("#select-subjectid-modal").val();
        paramObjModal.grade = $("#inp-grade-modal").val();
        paramObjModal.examDate = $("#inp-examDate-modal").val();
      };
      // B2 Validate 
      function validateDataModal(paramObjModal){
        "use strict"
      if(paramObjModal.studentid == 0){
        alert("Vui lòng chọn Sinh Viên")
        return false;
      };
      if(paramObjModal.subjectid == 0){
        alert("Vui lòng chọn Môn Học")
        return false;
      };
      if(paramObjModal.grade == ""){
        alert("Vui lòng Nhập Điểm")
        return false;
      };
      if(paramObjModal.examDate == ""){
        alert("Vui lòng Nhập Ngày Thi")
        return false;
      };
        return true ;
      }
      // B3 Gọi Api Thêm Mới
      function onCreateGrade(obj){
        var vDoituong = JSON.stringify(obj)
        $.ajax({
          url: "https://62454a477701ec8f724fb923.mockapi.io/api/v1/grades" ,
          type: "POST",
          data: vDoituong,
          contentType: "application/json",
          async: false,
          success: function(response){
            console.log(response);
            alert("Đã Thêm Điểm Mới Thành Công");
            $("#AddNew-Modal").modal("hide");
            location.reload();
          },
          error: function(error){
            alert("Thêm Mới Không Thành Công");
            console.log(error.responseText)
          }
        })
      }


      // hàm xử lý sự kiện load dữ liệu Grade vào table
      function loadDataToTable(paramGrade) {
            gSTT = 1
            gObjTable.clear();
            gObjTable.rows.add(paramGrade);
            gObjTable.draw();
        }

      // hàm xử lý sự kiện lấy dữ liệu của bảng
      function loadGradeData() {
            $.ajax({
                url: gBASE_URL + "/grades",
                type: "GET",
                async: false,
                success: function (res) {
                    //console.log(res);
                    gGrade = res
                    loadDataToTable(gGrade); // gán sự kiện load dữ liệu Grade vào table
                    console.log(gGrade);
                },
                error: function () {
                    alert("Load thông tin không thành công");
                }
            });
        }

      // gọi API lấy danh sách học sinh
      function StudentList(){
        $.ajax({
            url: gBASE_URL + "/students",
            type: "GET",
            dataType: "json",
            async:false,
            success: function(ketqua){
                gStudent = ketqua ;
            },
            error: function(error){
                alert(error.responseText)
                
            }
        })
      };
      // gọi API lấy danh sách Môn Học
      function SubjectList(){
    $.ajax({
        url: gBASE_URL + "/subjects",
        type: "GET",
        dataType: "json",
        async:false,
        success: function(ketqua){
            console.log(ketqua);
            gSubject = ketqua ;
        },
        error: function(error){
            alert(error.responseText)
            
        }
    })
  };
      // load data vào ô select học sinh
      function loadDataToSelectStudent(paramStudentObj){
        "use strict";
        // Thêm option mặc định
        $('#select-student').append($('<option>', {
            value: "0",
            text: "=== Chọn Sinh viên ==="
        }));
        // Thêm option mặc định
        $('#select-studentid-modal').append($('<option>', {
            value: "0",
            text: "=== Chọn Sinh viên ==="
        }));
        // Thêm các option từ dữ liệu
        for(var bI = 0; bI < paramStudentObj.length; bI++){
          $('#select-student').append($('<option>', {
            value: paramStudentObj[bI].id,
            text: paramStudentObj[bI].firstname + " "+ paramStudentObj[bI].lastname
          }));
          //Thêm các option từ dữ liệu vào ô select trên
          $('#select-studentid-modal').append($('<option>', {
            value: paramStudentObj[bI].id,
            text: paramStudentObj[bI].firstname + " "+ paramStudentObj[bI].lastname
          }));
        }      
        }      
      // load Môn học vào ô select
      function loadDataToSelectSubject(paramSubjectObj){
        "use strict";
        // Thêm option mặc định
        $('#select-subject').append($('<option>', {
            value: "0",
            text: "=== Chọn Môn học ==="
        }));
        $('#select-subjectid-modal').append($('<option>', {
            value: "0",
            text: "=== Chọn Môn học ==="
        }));
        // Thêm các option từ dữ liệu
        for(var bI = 0; bI < paramSubjectObj.length; bI++){
          $('#select-subject').append($('<option>', {
            value: paramSubjectObj[bI].id,
            text: paramSubjectObj[bI].subjectName
          }));
          $('#select-subjectid-modal').append($('<option>', {
            value: paramSubjectObj[bI].id,
            text: paramSubjectObj[bI].subjectName
          }));
        } 
      }
      // render từ id sang tên
      function getFullNameById(paramId){
        "use strict";
        var vStudentInfo = "";
        for (var bI= 0; bI< gStudent.length; bI++){
            if (gStudent[bI].id == paramId){
              vStudentInfo = gStudent[bI].firstname + " " + gStudent[bI].lastname;
            }
        }
        return vStudentInfo;
      }
      // render từ id sang tên môn học
      function getSubjectNameById(paramId){
        "use strict";
        var vSubjectInfo = "";
        for (var bI= 0; bI< gSubject.length; bI++){
            if (gSubject[bI].id == paramId){
              vSubjectInfo = gSubject[bI].subjectName;
            }
        }
        return vSubjectInfo;
    } 

      // hàm lọc data
      // Hàm xử lý khi click nút filter
      function onBtnFilterClick(){
        "use strict";
        var vObjectFilter = {
          student: "",
          subject: ""
        };

        // Bước 1: Thu thập dữ liệu từ select
        getDataFromSelect(vObjectFilter);
        console.log(vObjectFilter);

       
        // Bước 2: Kiểm tra dữ liệu - bỏ qua

        // Bước 3: Lọc dữ liệu
        var vResultFilter = filterData(vObjectFilter);
         // Bước 4: Hiển thị dữ liệu lên Datatable
         loadDataToTable(vResultFilter);
    }


      function getDataFromSelect(paramObjectFilter){
        "use strict";
        paramObjectFilter.student = $("#select-student option:selected").val();
        paramObjectFilter.subject = $("#select-subject option:selected").val();
      }
    
      function filterData(paramObjectFilter){
      "use strict";
      console.log("ok")
      var vFilterStudent = gGrade.filter(function(item){
        if (paramObjectFilter.student != 0 && paramObjectFilter.subject != 0){
          return (item.studentId == paramObjectFilter.student && item.subjectId == paramObjectFilter.subject)
        }
        if (paramObjectFilter.student == 0 && paramObjectFilter.subject != 0) {
          return (item.subjectId == paramObjectFilter.subject);
        } 
        if (paramObjectFilter.student != 0 && paramObjectFilter.subject == 0) {
          return (item.studentId == paramObjectFilter.student );
        } 
      })
      return vFilterStudent;
      
    }
    function onEditGrade(paramEditObj){
      $.ajax({
          url: "https://62454a477701ec8f724fb923.mockapi.io/api/v1/grades/" + gradeID,
          type: "PUT",
          data: JSON.stringify(paramEditObj),
          contentType: "application/json",
          async: false,
          success: function(response){
            console.log(response);
            alert("Đã Sửa Điểm  Thành Công");
            $("#AddNew-Modal").modal("hide");
            location.reload();
          },
          error: function(error){
            alert("Thêm Mới Không Thành Công");
            console.log(error.responseText)
          }
        })
    }


 })
</script>
</html>